diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/recipient-block-ack-agreement.cc ns-3.43/src/wifi/model/recipient-block-ack-agreement.cc
--- ns-3.42/src/wifi/model/recipient-block-ack-agreement.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/recipient-block-ack-agreement.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/recipient-block-ack-agreement.h ns-3.43/src/wifi/model/recipient-block-ack-agreement.h
--- ns-3.42/src/wifi/model/recipient-block-ack-agreement.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/recipient-block-ack-agreement.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/reduced-neighbor-report.cc ns-3.43/src/wifi/model/reduced-neighbor-report.cc
--- ns-3.42/src/wifi/model/reduced-neighbor-report.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/reduced-neighbor-report.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -168,7 +157,7 @@
                         << "band " << channel.GetPhyBand());
 
     // find the primary channel number
-    uint16_t startingFreq = 0;
+    MHz_u startingFreq = 0;
 
     switch (channel.GetPhyBand())
     {
@@ -200,7 +189,7 @@
     NS_ASSERT(nbrApInfoId < m_nbrApInfoFields.size());
 
     WifiPhyBand band = WIFI_PHY_BAND_UNSPECIFIED;
-    uint16_t width = 0;
+    MHz_u width = 0;
 
     switch (m_nbrApInfoFields.at(nbrApInfoId).operatingClass)
     {
@@ -256,7 +245,7 @@
 
     NS_ABORT_IF(band == WIFI_PHY_BAND_UNSPECIFIED || width == 0);
 
-    uint16_t startingFreq = 0;
+    MHz_u startingFreq = 0;
 
     switch (band)
     {
@@ -276,17 +265,17 @@
     }
 
     uint8_t primaryChannelNumber = m_nbrApInfoFields.at(nbrApInfoId).channelNumber;
-    uint16_t primaryChannelCenterFrequency = startingFreq + primaryChannelNumber * 5;
+    MHz_u primaryChannelCenterFrequency = startingFreq + primaryChannelNumber * 5;
 
     uint8_t channelNumber = 0;
-    uint16_t frequency = 0;
+    MHz_u frequency = 0;
 
     for (const auto& channel : WifiPhyOperatingChannel::m_frequencyChannels)
     {
-        if (std::get<2>(channel) == width && std::get<3>(channel) == WIFI_PHY_OFDM_CHANNEL &&
-            std::get<4>(channel) == band &&
-            primaryChannelCenterFrequency > std::get<1>(channel) - width / 2 &&
-            primaryChannelCenterFrequency < std::get<1>(channel) + width / 2)
+        if (channel.width == width && channel.type == FrequencyChannelType::OFDM &&
+            channel.band == band &&
+            primaryChannelCenterFrequency > (channel.frequency - (width / 2)) &&
+            primaryChannelCenterFrequency < (channel.frequency + (width / 2)))
         {
             // the center frequency of the primary channel falls into the frequency
             // range of this channel
@@ -301,17 +290,17 @@
                 // frequency channels overlap in the 2.4 GHz band, hence we have to check
                 // that the given primary channel center frequency can be the center frequency
                 // of the primary20 channel of the channel under consideration
-                switch (width)
+                switch (static_cast<uint16_t>(width))
                 {
                 case 20:
-                    if (std::get<1>(channel) == primaryChannelCenterFrequency)
+                    if (channel.frequency == primaryChannelCenterFrequency)
                     {
                         found = true;
                     }
                     break;
                 case 40:
-                    if (std::get<1>(channel) == primaryChannelCenterFrequency + 10 ||
-                        std::get<1>(channel) == primaryChannelCenterFrequency - 10)
+                    if ((channel.frequency == primaryChannelCenterFrequency + 10) ||
+                        (channel.frequency == primaryChannelCenterFrequency - 10))
                     {
                         found = true;
                     }
@@ -323,8 +312,8 @@
 
             if (found)
             {
-                channelNumber = std::get<0>(channel);
-                frequency = std::get<1>(channel);
+                channelNumber = channel.number;
+                frequency = channel.frequency;
                 break;
             }
         }
@@ -333,10 +322,10 @@
     NS_ABORT_IF(channelNumber == 0 || frequency == 0);
 
     WifiPhyOperatingChannel channel;
-    channel.Set(channelNumber, frequency, width, WIFI_STANDARD_UNSPECIFIED, band);
+    channel.Set({{channelNumber, frequency, width, band}}, WIFI_STANDARD_UNSPECIFIED);
 
-    uint16_t channelLowestFreq = frequency - width / 2;
-    uint16_t primaryChannelLowestFreq = primaryChannelCenterFrequency - 10;
+    MHz_u channelLowestFreq = frequency - width / 2;
+    MHz_u primaryChannelLowestFreq = primaryChannelCenterFrequency - 10;
     channel.SetPrimary20Index((primaryChannelLowestFreq - channelLowestFreq) / 20);
 
     return channel;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/reduced-neighbor-report.h ns-3.43/src/wifi/model/reduced-neighbor-report.h
--- ns-3.42/src/wifi/model/reduced-neighbor-report.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/reduced-neighbor-report.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/reference/error-rate-tables.cc ns-3.43/src/wifi/model/reference/error-rate-tables.cc
--- ns-3.42/src/wifi/model/reference/error-rate-tables.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/reference/error-rate-tables.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rohan Patidar <rpatidar@uw.edu>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/reference/error-rate-tables.h ns-3.43/src/wifi/model/reference/error-rate-tables.h
--- ns-3.42/src/wifi/model/reference/error-rate-tables.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/reference/error-rate-tables.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rohan Patidar <rpatidar@uw.edu>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -25,7 +14,8 @@
 #ifndef ERROR_RATE_TABLES_H
 #define ERROR_RATE_TABLES_H
 
-#include <cstdint>
+#include "ns3/wifi-units.h"
+
 #include <utility>
 #include <vector>
 
@@ -40,8 +30,8 @@
 const uint8_t ERROR_TABLE_BCC_MAX_NUM_MCS = 10;    //!< maximum number of MCSs for BCC
 const uint8_t ERROR_TABLE_LDPC_MAX_NUM_MCS = 12;   //!< maximum number of MCSs for LDPC
 
-/// Table of SNR (dB) and PER pairs
-typedef std::vector<std::pair<double /* SNR (dB) */, double /* PER */>> SnrPerTable;
+/// Table of SNR and PER pairs
+typedef std::vector<std::pair<dB_u /* SNR */, double /* PER */>> SnrPerTable;
 
 /// AWGN error table for BCC with reference size of 32 bytes
 extern const SnrPerTable AwgnErrorTableBcc32[ERROR_TABLE_BCC_MAX_NUM_MCS];
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/simple-frame-capture-model.cc ns-3.43/src/wifi/model/simple-frame-capture-model.cc
--- ns-3.42/src/wifi/model/simple-frame-capture-model.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/simple-frame-capture-model.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2017
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -48,7 +37,7 @@
                 DoubleValue(5),
                 MakeDoubleAccessor(&SimpleFrameCaptureModel::GetMargin,
                                    &SimpleFrameCaptureModel::SetMargin),
-                MakeDoubleChecker<double>());
+                MakeDoubleChecker<dB_u>());
     return tid;
 }
 
@@ -63,13 +52,13 @@
 }
 
 void
-SimpleFrameCaptureModel::SetMargin(double margin)
+SimpleFrameCaptureModel::SetMargin(dB_u margin)
 {
     NS_LOG_FUNCTION(this << margin);
     m_margin = margin;
 }
 
-double
+dB_u
 SimpleFrameCaptureModel::GetMargin() const
 {
     return m_margin;
@@ -79,7 +68,7 @@
 SimpleFrameCaptureModel::CaptureNewFrame(Ptr<Event> currentEvent, Ptr<Event> newEvent) const
 {
     NS_LOG_FUNCTION(this);
-    return WToDbm(currentEvent->GetRxPowerW()) + GetMargin() < WToDbm(newEvent->GetRxPowerW()) &&
+    return WToDbm(currentEvent->GetRxPower()) + GetMargin() < WToDbm(newEvent->GetRxPower()) &&
            IsInCaptureWindow(currentEvent->GetStartTime());
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/simple-frame-capture-model.h ns-3.43/src/wifi/model/simple-frame-capture-model.h
--- ns-3.42/src/wifi/model/simple-frame-capture-model.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/simple-frame-capture-model.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2017
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -21,6 +10,7 @@
 #define SIMPLE_FRAME_CAPTURE_MODEL_H
 
 #include "frame-capture-model.h"
+#include "wifi-units.h"
 
 namespace ns3
 {
@@ -47,17 +37,17 @@
     ~SimpleFrameCaptureModel() override;
 
     /**
-     * Sets the frame capture margin (dB).
+     * Sets the frame capture margin.
      *
-     * \param margin the frame capture margin in dB
+     * \param margin the frame capture margin
      */
-    void SetMargin(double margin);
+    void SetMargin(dB_u margin);
     /**
-     * Return the frame capture margin (dB).
+     * Return the frame capture margin.
      *
-     * \return the frame capture margin in dB
+     * \return the frame capture margin
      */
-    double GetMargin() const;
+    dB_u GetMargin() const;
 
     /**
      * This method returns whether the reception should be switched to a
@@ -72,7 +62,7 @@
     bool CaptureNewFrame(Ptr<Event> currentEvent, Ptr<Event> newEvent) const override;
 
   private:
-    double m_margin; ///< margin for determining if a new frame (dB)
+    dB_u m_margin; ///< margin for determining if a new frame
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/snr-tag.cc ns-3.43/src/wifi/model/snr-tag.cc
--- ns-3.42/src/wifi/model/snr-tag.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/snr-tag.cc	2024-10-09 16:41:10.128656900 -0700
@@ -3,18 +3,7 @@
  * Copyright (c) 2009 MIRKO BANCHI
  * Copyright (c) 2013 University of Surrey
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/snr-tag.h ns-3.43/src/wifi/model/snr-tag.h
--- ns-3.42/src/wifi/model/snr-tag.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/snr-tag.h	2024-10-09 16:41:10.128656900 -0700
@@ -3,18 +3,7 @@
  * Copyright (c) 2009 MIRKO BANCHI
  * Copyright (c) 2013 University of Surrey
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
